Index: /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/SEI.cpp
===================================================================
--- /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/SEI.cpp	(revision 1348)
+++ /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/SEI.cpp	(revision 1349)
@@ -1536,63 +1535,23 @@
 };
 Bool SEIAlternativeDepthInfo::checkCfg( const TComSlice* slice )
-{ 
+{
   // Check config values
-  Bool wrongConfig = false; 
-
-  
+  Bool wrongConfig = false;
+
+
   xCheckCfgRange( wrongConfig, m_alternativeDepthInfoCancelFlag , 0 , 1, "alternative_depth_info_cancel_flag");
   xCheckCfgRange( wrongConfig, m_depthType                      , 0 , 1, "depth_type"                       );
 
-  // TBD: Modify constraints according to the SEI semantics.   
-#if NH_MV_SEI_TBD
-  xCheckCfgRange( wrongConfig, m_numConstituentViewsGvdMinus1   , MINVAL , MAXVAL, "num_constituent_views_gvd_minus1 ");
-  xCheckCfgRange( wrongConfig, m_depthPresentGvdFlag            , MINVAL , MAXVAL, "depth_present_gvd_flag"           );
-  xCheckCfgRange( wrongConfig, m_zGvdFlag                       , MINVAL , MAXVAL, "z_gvd_flag"                       );
-  xCheckCfgRange( wrongConfig, m_intrinsicParamGvdFlag          , MINVAL , MAXVAL, "intrinsic_param_gvd_flag"         );
-  xCheckCfgRange( wrongConfig, m_rotationGvdFlag                , MINVAL , MAXVAL, "rotation_gvd_flag"                );
-  xCheckCfgRange( wrongConfig, m_translationGvdFlag             , MINVAL , MAXVAL, "translation_gvd_flag"             );
-  xCheckCfgRange( wrongConfig, m_signGvdZNearFlag[i]            , MINVAL , MAXVAL, "sign_gvd_z_near_flag"             );
-  xCheckCfgRange( wrongConfig, m_expGvdZNear[i]                 , MINVAL , MAXVAL, "exp_gvd_z_near"                   );
-  xCheckCfgRange( wrongConfig, m_manLenGvdZNearMinus1[i]        , MINVAL , MAXVAL, "man_len_gvd_z_near_minus1"        );
-  xCheckCfgRange( wrongConfig, m_manGvdZNear[i]                 , MINVAL , MAXVAL, "man_gvd_z_near"                   );
-  xCheckCfgRange( wrongConfig, m_signGvdZFarFlag[i]             , MINVAL , MAXVAL, "sign_gvd_z_far_flag"              );
-  xCheckCfgRange( wrongConfig, m_expGvdZFar[i]                  , MINVAL , MAXVAL, "exp_gvd_z_far"                    );
-  xCheckCfgRange( wrongConfig, m_manLenGvdZFarMinus1[i]         , MINVAL , MAXVAL, "man_len_gvd_z_far_minus1"         );
-  xCheckCfgRange( wrongConfig, m_manGvdZFar[i]                  , MINVAL , MAXVAL, "man_gvd_z_far"                    );
-  xCheckCfgRange( wrongConfig, m_precGvdFocalLength             , MINVAL , MAXVAL, "prec_gvd_focal_length"            );
-  xCheckCfgRange( wrongConfig, m_precGvdPrincipalPoint          , MINVAL , MAXVAL, "prec_gvd_principal_point"         );
-  xCheckCfgRange( wrongConfig, m_precGvdRotationParam           , MINVAL , MAXVAL, "prec_gvd_rotation_param"          );
-  xCheckCfgRange( wrongConfig, m_precGvdTranslationParam        , MINVAL , MAXVAL, "prec_gvd_translation_param"       );
-  xCheckCfgRange( wrongConfig, m_signGvdFocalLengthX[i]         , MINVAL , MAXVAL, "sign_gvd_focal_length_x"          );
-  xCheckCfgRange( wrongConfig, m_expGvdFocalLengthX[i]          , MINVAL , MAXVAL, "exp_gvd_focal_length_x"           );
-  xCheckCfgRange( wrongConfig, m_manGvdFocalLengthX[i]          , MINVAL , MAXVAL, "man_gvd_focal_length_x"           );
-  xCheckCfgRange( wrongConfig, m_signGvdFocalLengthY[i]         , MINVAL , MAXVAL, "sign_gvd_focal_length_y"          );
-  xCheckCfgRange( wrongConfig, m_expGvdFocalLengthY[i]          , MINVAL , MAXVAL, "exp_gvd_focal_length_y"           );
-  xCheckCfgRange( wrongConfig, m_manGvdFocalLengthY[i]          , MINVAL , MAXVAL, "man_gvd_focal_length_y"           );
-  xCheckCfgRange( wrongConfig, m_signGvdPrincipalPointX[i]      , MINVAL , MAXVAL, "sign_gvd_principal_point_x"       );
-  xCheckCfgRange( wrongConfig, m_expGvdPrincipalPointX[i]       , MINVAL , MAXVAL, "exp_gvd_principal_point_x"        );
-  xCheckCfgRange( wrongConfig, m_manGvdPrincipalPointX[i]       , MINVAL , MAXVAL, "man_gvd_principal_point_x"        );
-  xCheckCfgRange( wrongConfig, m_signGvdPrincipalPointY[i]      , MINVAL , MAXVAL, "sign_gvd_principal_point_y"       );
-  xCheckCfgRange( wrongConfig, m_expGvdPrincipalPointY[i]       , MINVAL , MAXVAL, "exp_gvd_principal_point_y"        );
-  xCheckCfgRange( wrongConfig, m_manGvdPrincipalPointY[i]       , MINVAL , MAXVAL, "man_gvd_principal_point_y"        );
-  xCheckCfgRange( wrongConfig, m_signGvdR[i][j][k]              , MINVAL , MAXVAL, "sign_gvd_r"                       );
-  xCheckCfgRange( wrongConfig, m_expGvdR[i][j][k]               , MINVAL , MAXVAL, "exp_gvd_r"                        );
-  xCheckCfgRange( wrongConfig, m_manGvdR[i][j][k]               , MINVAL , MAXVAL, "man_gvd_r"                        );
-  xCheckCfgRange( wrongConfig, m_signGvdTX[i]                   , MINVAL , MAXVAL, "sign_gvd_t_x"                     );
-  xCheckCfgRange( wrongConfig, m_expGvdTX[i]                    , MINVAL , MAXVAL, "exp_gvd_t_x"                      );
-  xCheckCfgRange( wrongConfig, m_manGvdTX[i]                    , MINVAL , MAXVAL, "man_gvd_t_x"                      );
-#endif  
-  xCheckCfgRange( wrongConfig, m_minOffsetXFrac                 , 0 , 255, "min_offset_x_frac"                );  
-  xCheckCfgRange( wrongConfig, m_maxOffsetXFrac                 , 0 , 255, "max_offset_x_frac"                );
-  xCheckCfgRange( wrongConfig, m_offsetYPresentFlag             , 0 , 1, "offset_y_present_flag"            );  
-  xCheckCfgRange( wrongConfig, m_minOffsetYFrac                 , 0 , 255, "min_offset_y_frac"                );  
-  xCheckCfgRange( wrongConfig, m_maxOffsetYFrac                 , 0 , 255, "max_offset_y_frac"                );
-  xCheckCfgRange( wrongConfig, m_warpMapSizePresentFlag         , 0 , 1, "warp_map_size_present_flag"       );
-  xCheckCfgRange( wrongConfig, m_warpMapWidthMinus2             , 0 , (slice->getSPS()->getPicWidthInLumaSamples()-2), "warp_map_width_minus2"            );
-  xCheckCfgRange( wrongConfig, m_warpMapHeightMinus2            , 0 , ((slice->getSPS()->getPicHeightInLumaSamples()>>(Int)m_offsetYPresentFlag)-2), "warp_map_height_minus2"           );
-
-  return wrongConfig; 
-
-};
+  xCheckCfgRange( wrongConfig, m_numConstituentViewsGvdMinus1   , 1 , 1, "num_constituent_views_gvd_minus1 "); // 1: 3 views only, cuurent.
+  xCheckCfgRange( wrongConfig, m_depthPresentGvdFlag            , 0 , 1, "depth_present_gvd_flag"           );
+  xCheckCfgRange( wrongConfig, m_zGvdFlag                       , 0 , 1, "z_gvd_flag"                       );
+  xCheckCfgRange( wrongConfig, m_intrinsicParamGvdFlag          , 0 , 1, "intrinsic_param_gvd_flag"         );
+  xCheckCfgRange( wrongConfig, m_rotationGvdFlag                , 0 , 1, "rotation_gvd_flag"                );
+  xCheckCfgRange( wrongConfig, m_translationGvdFlag             , 0 , 1, "translation_gvd_flag"             );
+
+  return wrongConfig;
+
+};
+
 #endif
 
Index: /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/SEI.h
===================================================================
--- /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/SEI.h	(revision 1348)
+++ /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/SEI.h	(revision 1349)
@@ -42,5 +42,5 @@
 #include "CommonDef.h"
 #include "libmd5/MD5.h"
- 
+
 
 #if NH_MV_SEI
@@ -54,6 +54,6 @@
 class TComSPS;
 #if NH_MV_SEI
-class TComSlice; 
-class SEIScalableNesting; 
+class TComSlice;
+class SEIScalableNesting;
 #endif
 
@@ -128,6 +128,6 @@
 
 #if NH_MV_SEI
-  static SEI*        getNewSEIMessage         ( SEI::PayloadType payloadType ); 
-  Bool               insertSei                ( Int curLayerId, Int curPoc, Int curTid, Int curNaluType ) const;  
+  static SEI*        getNewSEIMessage         ( SEI::PayloadType payloadType );
+  Bool               insertSei                ( Int curLayerId, Int curPoc, Int curTid, Int curNaluType ) const;
 
 
@@ -139,17 +139,17 @@
   Void               xCheckCfgRange           ( Bool& wrongConfig, Int val, Int minVal, Int maxVal, const Char* seName );
   Void               xCheckCfg                ( Bool& wrongConfig, Bool cond, const Char* errStr );
-  Void               xAddGeneralOpts          ( po::Options &opts, IntAry1d defAppLayerIds, IntAry1d defAppPocs, IntAry1d defAppTids, IntAry1d defAppVclNaluTypes, 
+  Void               xAddGeneralOpts          ( po::Options &opts, IntAry1d defAppLayerIds, IntAry1d defAppPocs, IntAry1d defAppTids, IntAry1d defAppVclNaluTypes,
                                                 Int defSeiNaluId, Int defPositionInSeiNalu, Bool defModifyByEncoder );
-    // Filters where to insert SEI in the bitstream. 
-  // When the respected vector is empty, all layersIds, POCs, Tids, and Nalu types are used. 
-  IntAry1d                       m_applicableLayerIds; 
-  IntAry1d                       m_applicablePocs; 
-  IntAry1d                       m_applicableTids; 
-  IntAry1d                       m_applicableVclNaluTypes;     
+    // Filters where to insert SEI in the bitstream.
+  // When the respected vector is empty, all layersIds, POCs, Tids, and Nalu types are used.
+  IntAry1d                       m_applicableLayerIds;
+  IntAry1d                       m_applicablePocs;
+  IntAry1d                       m_applicableTids;
+  IntAry1d                       m_applicableVclNaluTypes;
 
   Int                            m_payloadType;              // Payload type
-  Int                            m_seiNaluId;                // Identifies to which NAL unit  the SEI is added. 
+  Int                            m_seiNaluId;                // Identifies to which NAL unit  the SEI is added.
   Int                            m_positionInSeiNalu;        // Identifies the order within the NAL unit
-  Bool                           m_modifyByEncoder;          // Don't use the SEI cfg-file, but let let the encoder setup the NALU.   
+  Bool                           m_modifyByEncoder;          // Don't use the SEI cfg-file, but let let the encoder setup the NALU.
 
   SEIScalableNesting*            m_scalNestSeiContThisSei;   // Pointer to scalable nesting SEI containing the SEI. When NULL, the SEI is not nested.
@@ -214,5 +214,5 @@
   Bool m_noParameterSetUpdateFlag;
   Int numSpsIdsMinus1;
-  std::vector<Int> activeSeqParameterSetId; 
+  std::vector<Int> activeSeqParameterSetId;
 };
 
@@ -527,5 +527,5 @@
     SEIMasteringDisplayColourVolume() {}
     virtual ~SEIMasteringDisplayColourVolume(){}
-    
+
     TComSEIMasteringDisplay values;
 };
@@ -611,5 +611,5 @@
 
     public:
-      Int     m_mcts_id;  
+      Int     m_mcts_id;
       Bool    m_display_tile_set_flag;
       Int     m_num_tile_rects_in_set; //_minus1;
@@ -667,5 +667,5 @@
   SEILayersNotPresent ( ) { };
   ~SEILayersNotPresent( ) { };
-  SEI* getCopy( ) const { return new SEILayersNotPresent(*this); }; 
+  SEI* getCopy( ) const { return new SEILayersNotPresent(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -689,5 +689,5 @@
   SEIInterLayerConstrainedTileSets ( ) { };
   ~SEIInterLayerConstrainedTileSets( ) { };
-  SEI* getCopy( ) const { return new SEIInterLayerConstrainedTileSets(*this); }; 
+  SEI* getCopy( ) const { return new SEIInterLayerConstrainedTileSets(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -731,5 +731,5 @@
   SEIBspNesting ( ) { };
   ~SEIBspNesting( ) { };
-  SEI* getCopy( ) const { return new SEIBspNesting(*this); }; 
+  SEI* getCopy( ) const { return new SEIBspNesting(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -750,5 +750,5 @@
   SEIBspInitialArrivalTime ( ) { };
   ~SEIBspInitialArrivalTime( ) { };
-  SEI* getCopy( ) const { return new SEIBspInitialArrivalTime(*this); }; 
+  SEI* getCopy( ) const { return new SEIBspInitialArrivalTime(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -767,9 +767,9 @@
   SEISubBitstreamProperty ( ) { };
   ~SEISubBitstreamProperty( ) { };
-  SEI* getCopy( ) const { return new SEISubBitstreamProperty(*this); }; 
-
-  Void setupFromCfgFile( const Char*      cfgFile );
-  Bool checkCfg        ( const TComSlice* slice   );
-  Void resizeArrays    ( ); 
+  SEI* getCopy( ) const { return new SEISubBitstreamProperty(*this); };
+
+  Void setupFromCfgFile( const Char*      cfgFile );
+  Bool checkCfg        ( const TComSlice* slice   );
+  Void resizeArrays    ( );
 
   Int       m_sbPropertyActiveVpsId;
@@ -788,5 +788,5 @@
   SEIAlphaChannelInfo ( ) { };
   ~SEIAlphaChannelInfo( ) { };
-  SEI* getCopy( ) const { return new SEIAlphaChannelInfo(*this); }; 
+  SEI* getCopy( ) const { return new SEIAlphaChannelInfo(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -807,15 +807,15 @@
 public:
   PayloadType payloadType( ) const { return OVERLAY_INFO; }
-  SEIOverlayInfo ( );  
+  SEIOverlayInfo ( );
   ~SEIOverlayInfo( ) { };
-  SEI* getCopy( ) const { return new SEIOverlayInfo(*this); }; 
-
-  Void setupFromCfgFile( const Char*      cfgFile );  
-  Bool checkCfg        ( const TComSlice* slice   );  
-
-  const Int m_numOverlaysMax; 
-  const Int m_numOverlayElementsMax; 
+  SEI* getCopy( ) const { return new SEIOverlayInfo(*this); };
+
+  Void setupFromCfgFile( const Char*      cfgFile );
+  Bool checkCfg        ( const TComSlice* slice   );
+
+  const Int m_numOverlaysMax;
+  const Int m_numOverlayElementsMax;
   const Int m_numStringBytesMax;  //incl. null termination byte
-  
+
   Bool      m_overlayInfoCancelFlag;
   Int       m_overlayContentAuxIdMinus128;
@@ -833,5 +833,5 @@
   IntAry1d  m_numOverlayElementsMinus1;
   IntAry2d  m_overlayElementLabelMin;
-  IntAry2d  m_overlayElementLabelMax;  
+  IntAry2d  m_overlayElementLabelMax;
   StringAry1d  m_overlayLanguage;
   StringAry1d  m_overlayName;
@@ -846,5 +846,5 @@
   SEITemporalMvPredictionConstraints ( ) { };
   ~SEITemporalMvPredictionConstraints( ) { };
-  SEI* getCopy( ) const { return new SEITemporalMvPredictionConstraints(*this); }; 
+  SEI* getCopy( ) const { return new SEITemporalMvPredictionConstraints(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -862,5 +862,5 @@
   SEIFrameFieldInfo ( ) { };
   ~SEIFrameFieldInfo( ) { };
-  SEI* getCopy( ) const { return new SEIFrameFieldInfo(*this); }; 
+  SEI* getCopy( ) const { return new SEIFrameFieldInfo(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -880,5 +880,5 @@
   SEIThreeDimensionalReferenceDisplaysInfo ( ) { };
   ~SEIThreeDimensionalReferenceDisplaysInfo( ) { };
-  SEI* getCopy( ) const { return new SEIThreeDimensionalReferenceDisplaysInfo(*this); }; 
+  SEI* getCopy( ) const { return new SEIThreeDimensionalReferenceDisplaysInfo(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -887,5 +887,5 @@
   Int getNumRefDisplaysMinus1( ) const
   {
-    return m_numRefDisplaysMinus1; 
+    return m_numRefDisplaysMinus1;
   }
 
@@ -907,5 +907,5 @@
   {
     Int numReferenceDiaplays = getNumRefDisplaysMinus1() + 1;
-  
+
     m_leftViewId    .resize( numReferenceDiaplays );
     m_rightViewId   .resize( numReferenceDiaplays );
@@ -920,6 +920,6 @@
   UInt getMantissaReferenceDisplayWidthLen  ( Int i ) const ;
   UInt getMantissaReferenceViewingDistanceLen  ( Int i ) const ;
-private: 
-  UInt xGetSyntaxElementLen( Int expo, Int prec, Int val ) const; 
+private:
+  UInt xGetSyntaxElementLen( Int expo, Int prec, Int val ) const;
 };
 
@@ -929,10 +929,10 @@
     public:
         PayloadType payloadType( ) const { return DEPTH_REPRESENTATION_INFO; }
-        SEIDepthRepresentationInfo ( ) 
+        SEIDepthRepresentationInfo ( )
         {
             m_currLayerID=-1;
         };
         ~SEIDepthRepresentationInfo( ) { };
-        SEI* getCopy( ) const { return new SEIDepthRepresentationInfo(*this); }; 
+        SEI* getCopy( ) const { return new SEIDepthRepresentationInfo(*this); };
 
         Void setupFromCfgFile( const Char*      cfgFile );
@@ -977,5 +977,5 @@
             for(i=0;i<m_depth_nonlinear_representation_model.size();i++)
                 m_depth_nonlinear_representation_model[i].clear();
-            m_depth_nonlinear_representation_model.clear();            
+            m_depth_nonlinear_representation_model.clear();
 
         }
@@ -1001,5 +1001,5 @@
   SEIMultiviewSceneInfo ( ) { };
   ~SEIMultiviewSceneInfo( ) { };
-  SEI* getCopy( ) const { return new SEIMultiviewSceneInfo(*this); }; 
+  SEI* getCopy( ) const { return new SEIMultiviewSceneInfo(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -1017,5 +1017,5 @@
   SEIMultiviewAcquisitionInfo ( ) { };
   ~SEIMultiviewAcquisitionInfo( ) { };
-  SEI* getCopy( ) const { return new SEIMultiviewAcquisitionInfo(*this); }; 
+  SEI* getCopy( ) const { return new SEIMultiviewAcquisitionInfo(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
@@ -1024,19 +1024,19 @@
   Int getNumViewsMinus1( ) const
   {
-    Int numViewsMinus1; 
+    Int numViewsMinus1;
     if( m_scalNestSeiContThisSei != NULL )
     {
       numViewsMinus1 = m_scalNestSeiContThisSei->m_nestingNumLayersMinus1;
-    }  
+    }
     else
     {
-      numViewsMinus1 = 0; 
+      numViewsMinus1 = 0;
     }
-    return numViewsMinus1; 
+    return numViewsMinus1;
   }
-  
+
   Void resizeArrays( )
   {
-    Int numViews = getNumViewsMinus1() + 1;      
+    Int numViews = getNumViewsMinus1() + 1;
     m_signFocalLengthX       .resize( numViews );
     m_exponentFocalLengthX   .resize( numViews );
@@ -1055,7 +1055,7 @@
     m_mantissaSkewFactor     .resize( numViews );
 
-    m_signR                  .resize( numViews );    
+    m_signR                  .resize( numViews );
     m_exponentR              .resize( numViews );
-    m_mantissaR              .resize( numViews );  
+    m_mantissaR              .resize( numViews );
     m_signT                  .resize( numViews );
     m_exponentT              .resize( numViews );
@@ -1064,7 +1064,7 @@
     for( Int i = 0; i  < numViews ; i++ )
     {
-      m_signR    [i].resize( 3 );    
+      m_signR    [i].resize( 3 );
       m_exponentR[i].resize( 3 );
-      m_mantissaR[i].resize( 3 );  
+      m_mantissaR[i].resize( 3 );
       m_signT    [i].resize( 3 );
       m_exponentT[i].resize( 3 );
@@ -1073,11 +1073,11 @@
       for (Int j = 0; j < 3; j++)
       {
-        m_signR    [i][j].resize( 3 );    
+        m_signR    [i][j].resize( 3 );
         m_exponentR[i][j].resize( 3 );
-        m_mantissaR[i][j].resize( 3 );  
+        m_mantissaR[i][j].resize( 3 );
       }
     }
   }
-  
+
   UInt getMantissaFocalLengthXLen   ( Int i ) const ;
   UInt getMantissaFocalLengthYLen   ( Int i ) const ;
@@ -1117,6 +1117,6 @@
   IntAry2d  m_exponentT;
   IntAry2d  m_mantissaT;
-private: 
-  UInt xGetSyntaxElementLen( Int expo, Int prec, Int val ) const; 
+private:
+  UInt xGetSyntaxElementLen( Int expo, Int prec, Int val ) const;
 };
 
@@ -1129,10 +1129,10 @@
   SEIMultiviewViewPosition ( ) { };
   ~SEIMultiviewViewPosition( ) { };
-  SEI* getCopy( ) const { return new SEIMultiviewViewPosition(*this); }; 
+  SEI* getCopy( ) const { return new SEIMultiviewViewPosition(*this); };
 
   Void setupFromCfgFile( const Char*      cfgFile );
   Void setupFromSlice  ( const TComSlice* slice   );
   Bool checkCfg        ( const TComSlice* slice   );
-  
+
   Int       m_numViewsMinus1;
   IntAry1d  m_viewPosition;
@@ -1146,12 +1146,86 @@
   SEIAlternativeDepthInfo ( ) { };
   ~SEIAlternativeDepthInfo( ) { };
-  SEI* getCopy( ) const { return new SEIAlternativeDepthInfo(*this); }; 
-
-  Void setupFromCfgFile( const Char*      cfgFile );  
-  Bool checkCfg        ( const TComSlice* slice   );
+  SEI* getCopy( ) const { return new SEIAlternativeDepthInfo(*this); };
+
+  Void setupFromCfgFile( const Char*      cfgFile );
+  Bool checkCfg        ( const TComSlice* slice   );
+
+  Void resizeArrays( )
+  {
+    const Int numViews = 3; // getNumConstituentViewsGvdMinus1() + 1;
+
+    m_signGvdZNearFlag.resize(3);
+    m_expGvdZNear.resize(3);
+    m_manLenGvdZNearMinus1.resize(3);
+    m_manGvdZNear.resize(3);
+    m_signGvdZFarFlag.resize(3);
+    m_expGvdZFar.resize(3);
+    m_manLenGvdZFarMinus1.resize(3);
+    m_manGvdZFar.resize(3);
+
+    m_signGvdFocalLengthX.resize(3);
+    m_expGvdFocalLengthX.resize(3);
+    m_manGvdFocalLengthX.resize(3);
+    m_signGvdFocalLengthY.resize(3);
+    m_expGvdFocalLengthY.resize(3);
+    m_manGvdFocalLengthY.resize(3);
+    m_signGvdPrincipalPointX.resize(3);
+    m_expGvdPrincipalPointX.resize(3);
+    m_manGvdPrincipalPointX.resize(3);
+    m_signGvdPrincipalPointY.resize(3);
+    m_expGvdPrincipalPointY.resize(3);
+    m_manGvdPrincipalPointY.resize(3);
+
+    m_signGvdR.resize(3);
+    m_expGvdR.resize(3);
+    m_manGvdR.resize(3);
+
+    m_signGvdTX.resize(3);
+    m_expGvdTX.resize(3);
+    m_manGvdTX.resize(3);
+
+    for( Int i = 0; i < numViews; i++ )
+    {
+      m_signGvdZNearFlag[i].resize(3);
+      m_expGvdZNear[i].resize(3);
+      m_manLenGvdZNearMinus1[i].resize(3);
+      m_manGvdZNear[i].resize(3);
+      m_signGvdZFarFlag[i].resize(3);
+      m_expGvdZFar[i].resize(3);
+      m_manLenGvdZFarMinus1[i].resize(3);
+      m_manGvdZFar[i].resize(3);
+
+      m_signGvdFocalLengthX[i].resize(3);
+      m_expGvdFocalLengthX[i].resize(3);
+      m_manGvdFocalLengthX[i].resize(3);
+      m_signGvdFocalLengthY[i].resize(3);
+      m_expGvdFocalLengthY[i].resize(3);
+      m_manGvdFocalLengthY[i].resize(3);
+      m_signGvdPrincipalPointX[i].resize(3);
+      m_expGvdPrincipalPointX[i].resize(3);
+      m_manGvdPrincipalPointX[i].resize(3);
+      m_signGvdPrincipalPointY[i].resize(3);
+      m_expGvdPrincipalPointY[i].resize(3);
+      m_manGvdPrincipalPointY[i].resize(3);
+
+      m_signGvdR[i].resize(3);
+      m_expGvdR[i].resize(3);
+      m_manGvdR[i].resize(3);
+      for( Int j = 0; j < 3; j++ )
+      {
+        m_signGvdR[i][j].resize(3);
+        m_expGvdR[i][j].resize(3);
+        m_manGvdR[i][j].resize(3);
+      }
+
+      m_signGvdTX[i].resize(3);
+      m_expGvdTX[i].resize(3);
+      m_manGvdTX[i].resize(3);
+    }
+
+  }
 
   Bool      m_alternativeDepthInfoCancelFlag;
   Int       m_depthType;
-#if NH_MV_SEI_TBD
   Int       m_numConstituentViewsGvdMinus1;
   Bool      m_depthPresentGvdFlag;
@@ -1160,35 +1234,34 @@
   Bool      m_rotationGvdFlag;
   Bool      m_translationGvdFlag;
-  BoolAry1d m_signGvdZNearFlag;
-  IntAry1d  m_expGvdZNear;
-  IntAry1d  m_manLenGvdZNearMinus1;
-  IntAry1d  m_manGvdZNear;
-  BoolAry1d m_signGvdZFarFlag;
-  IntAry1d  m_expGvdZFar;
-  IntAry1d  m_manLenGvdZFarMinus1;
-  IntAry1d  m_manGvdZFar;
+  BoolAry2d m_signGvdZNearFlag;
+  IntAry2d  m_expGvdZNear;
+  IntAry2d  m_manLenGvdZNearMinus1;
+  IntAry2d  m_manGvdZNear;
+  BoolAry2d m_signGvdZFarFlag;
+  IntAry2d  m_expGvdZFar;
+  IntAry2d  m_manLenGvdZFarMinus1;
+  IntAry2d  m_manGvdZFar;
   Int       m_precGvdFocalLength;
   Int       m_precGvdPrincipalPoint;
   Int       m_precGvdRotationParam;
   Int       m_precGvdTranslationParam;
-  BoolAry1d m_signGvdFocalLengthX;
-  IntAry1d  m_expGvdFocalLengthX;
-  IntAry1d  m_manGvdFocalLengthX;
-  BoolAry1d m_signGvdFocalLengthY;
-  IntAry1d  m_expGvdFocalLengthY;
-  IntAry1d  m_manGvdFocalLengthY;
-  BoolAry1d m_signGvdPrincipalPointX;
-  IntAry1d  m_expGvdPrincipalPointX;
-  IntAry1d  m_manGvdPrincipalPointX;
-  BoolAry1d m_signGvdPrincipalPointY;
-  IntAry1d  m_expGvdPrincipalPointY;
-  IntAry1d  m_manGvdPrincipalPointY;
+  BoolAry2d m_signGvdFocalLengthX;
+  IntAry2d  m_expGvdFocalLengthX;
+  IntAry2d  m_manGvdFocalLengthX;
+  BoolAry2d m_signGvdFocalLengthY;
+  IntAry2d  m_expGvdFocalLengthY;
+  IntAry2d  m_manGvdFocalLengthY;
+  BoolAry2d m_signGvdPrincipalPointX;
+  IntAry2d  m_expGvdPrincipalPointX;
+  IntAry2d  m_manGvdPrincipalPointX;
+  BoolAry2d m_signGvdPrincipalPointY;
+  IntAry2d  m_expGvdPrincipalPointY;
+  IntAry2d  m_manGvdPrincipalPointY;
   BoolAry3d m_signGvdR;
   IntAry3d  m_expGvdR;
   IntAry3d  m_manGvdR;
-  BoolAry1d m_signGvdTX;
-  IntAry1d  m_expGvdTX;
-  IntAry1d  m_manGvdTX;
-#endif
+  BoolAry2d m_signGvdTX;
+  IntAry2d  m_expGvdTX;
+  IntAry2d  m_manGvdTX;
   Int       m_minOffsetXInt;
   Int       m_minOffsetXFrac;
Index: /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/TComBitStream.cpp
===================================================================
--- /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/TComBitStream.cpp	(revision 1348)
+++ /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/TComBitStream.cpp	(revision 1349)
@@ -113,5 +113,7 @@
 {
   assert( uiNumberOfBits <= 32 );
+#if !NH_3D
   assert( uiNumberOfBits == 32 || (uiBits & (~0 << uiNumberOfBits)) == 0 );
+#endif
 
   /* any modulo 8 remainder of num_total_bits cannot be written this time,
@@ -264,7 +266,7 @@
   {
       Bool oldJustDoIt = g_bJustDoIt;
-      g_bJustDoIt = true; 
+      g_bJustDoIt = true;
       writeToTraceFile( "Bits: ", m_numBitsRead, true );
-      g_bJustDoIt = oldJustDoIt; 
+      g_bJustDoIt = oldJustDoIt;
   }
 #endif
